package com.chinaitop.depot.basic.mapper;

import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.chinaitop.depot.basic.model.BasicWarehouseExample;
import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicWarehouseVO;
import org.apache.ibatis.annotations.Param;

public interface BasicWarehouseMapper {
    int countByExample(BasicWarehouseExample example);

    int deleteByExample(BasicWarehouseExample example);

    int deleteByPrimaryKey(Integer warehouseId);

    int insert(BasicWarehouse record);

    int insertSelective(BasicWarehouse record);

    List<BasicWarehouse> selectByExample(BasicWarehouseExample example);

    BasicWarehouse selectByPrimaryKey(Integer warehouseId);

    int updateByExampleSelective(@Param("record") BasicWarehouse record, @Param("example") BasicWarehouseExample example);

    int updateByExample(@Param("record") BasicWarehouse record, @Param("example") BasicWarehouseExample example);

    int updateByPrimaryKeySelective(BasicWarehouse record);

    int updateByPrimaryKey(BasicWarehouse record);

    /**
     * 修改货位表出入库状态crk_status
     * 
     * @param param
     */
	void updateWareStatus(Map<String, Object> param);

	/**
	 * 查询货位列表按仓房名称排序
	 * 
	 * @param param
	 * @return
	 */
	List<BasicWarehouse> getList(Map<String, Object> param);

	/**
	 * 查询对应货位的封仓状态
	 * 
	 * @param param
	 * @return
	 */
	List<Map<String, String>> queryFcdate(Map<String, Object> param);

	BasicWarehouseVO getWareDataByHwbm(String hwbm);
}