package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicEnum;
import com.chinaitop.depot.basic.model.BasicEnumExample;
import com.github.pagehelper.PageInfo;

public interface BasicEnumService {

	/**
	 * 新增枚举大类
	 * @param basicEnum
	 * @throws Exception
	 */
	public BasicEnum saveEnum(BasicEnum basicEnum) throws Exception;

	/**
	 * 删除枚举大类
	 * @param id
	 * @throws Exception
	 */
	public void removeEnum(Integer id) throws Exception;

	/**
	 * 修改枚举大类
	 * @param basicEnum
	 * @throws Exception
	 */
	public void updateEnum(BasicEnum basicEnum) throws Exception;

	/**
	 * 按照ID查询一条枚举大类信息
	 * @param basicEnum
	 * @throws Exception
	 */
	public BasicEnum findByParmeryKeyEnum(Integer id) throws Exception;

	/**
	 * 按照条件查询枚举大类信息
	 * @param basicEnum
	 * @throws Exception
	 */
	public List<BasicEnum> findConditionEnum(BasicEnumExample basicEnumExample) throws Exception;

	/**
	 * 按父级ID获取所有枚举数据
	 * @return
	 * @throws Exception
	 */
	public Map<Integer, List<BasicEnum>> findEnumObjParentId() throws Exception;

	/**
	 * 按数据ID获取所有枚举数据
	 * @return
	 * @throws Exception
	 */
	public Map<Object, Object> findEnumObjEnumId() throws Exception;

	/**
	 * 获取以Id为对象的字典值
	 * @return
	 */
	List<BasicEnum> queryByTree();
	
	/**
	 * 获取所有子节点
	 * @param enumid
	 * @return
	 */
	List<BasicEnum> queryAllChildren(Integer enumid);

	/**
     * 导入
     * @param list
     */
	String importData(List<List<String>> list);

	/**
	 * 查询字典数据列表，支持分页
	 * 
	 * @param pageNum
	 * @param pageSize
	 * @param parentId
	 * @param enumName
	 * @return
	 * @throws Exception 
	 */
	public PageInfo<BasicEnum> getListPage(Integer pageNum, Integer pageSize, Integer parentId, String enumName) throws Exception;

	/**
	 * 更新数据字典大类信息
	 * 
	 * @param enumJson
	 * @return 
	 * @throws Exception 
	 */
	public Map<String, Object> updateOrSave(String enumJson) throws Exception;

	/**
	 * 按数据字典大类ID逻辑删除数据字典大类信息
	 * 
	 * @param id
	 * @return
	 * @throws Exception 
	 */
	public Map<String, Object> removeObj(Integer id) throws Exception;

}
