package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicKeeperHouse;
import com.chinaitop.depot.basic.model.BasicKeeperHouseExample;

public interface BasicKeeperHouseService {

	/**
	 * 新增
	 * @param keeperHouse
	 */
	void save(BasicKeeperHouse keeperHouse);

	/**
	 * 删除
	 * @param example
	 */
	void delete(BasicKeeperHouseExample example);

	/**
	 * 按条件查询
	 * @param example
	 * @return
	 */
	List<BasicKeeperHouse> findCondition(BasicKeeperHouseExample example);

	/**
	 * 通过员工ID和仓房ID删除一条数据
	 * 
	 * @param keeperId 员工ID
	 * @param houseId 仓房ID
	 */
	void deleteByKeeperIdAndHouseId(Integer keeperId,String houseId);

	/**
	 * 通过员工ID和仓房ID查询一条数据
	 * 
	 * @param keeperId 员工ID
	 * @param houseId 仓房ID
	 * @return
	 */
	BasicKeeperHouse getHouseKeeperBykeeperIdAndHouseId(Integer keeperId,String houseId);

	/**
	 * 获取一个仓房的所有保管员的员工数据ID
	 * 
	 * @param orgId 单位ID
	 * @param i 仓房ID
	 * @return
	 */
	List<Integer> getKeeperId(Integer orgId, String houseId);

	/**
	 * 更新保管员管理的仓房
	 * 
	 * @param houseId
	 * @param receiveId
	 * @param transferId
	 * @param roleId
	 * @return
	 */
	Map<String, Object> updateKeeperHouse(String houseId, Integer receiveId, Integer transferId, Integer roleId);

}
