package com.chinaitop.depot.basic.service;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.model.BasicTank;
import com.chinaitop.depot.basic.model.BasicTankExample;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

public interface BasicTankService {


    List<BasicTank> findBasicTank(BasicTankExample example);
    List<BasicTank> findBasicTankNew(Map<String, Object> map);
    List<BasicTank> selectAgentByExample(Map<String, Object> map);

    List<BasicTank> findBasicTacrk(BasicTankExample example);

    void saveOrEdit(HttpServletRequest request, BasicTank basicTank, Integer orgId);

    Boolean findStorageTankCodeList(BasicTankExample basicTankExample, String id);

    BasicTank findByPrimary(String id);

    void updateBasicTank(String id, Integer delFlag) throws Exception;

    String importData(List<List<String>> list, JSONObject user, String orgCode);

    BasicTank findByBasicBankPrimary(String houseId);

	public BasicTank findByStorehousebank(String id, Integer orgId) throws Exception;

    /**
     * 获取油罐的保管员
     * 
     * @param id
     * @param orgId
     * @param b
     * @return
     */
	String getStorehouseKeeper(String id, Integer orgId, boolean b);

	/**
	 * 查询油罐分页列表
	 * 
	 * @param pageNum
	 * @param pageSize
	 * @param libraryType
	 * @param modelMap
	 * @return
	 */
	PageInfo<BasicTank> getPageList(Integer pageNum, Integer pageSize, String libraryType,
			Map<String, Object> modelMap) throws Exception;

	/**
	 * 封装油罐初始化对象数据
	 * 
	 * @param orgId
	 * @return
	 * @throws Exception
	 */
	Map<String, Object> getBasicTankList(Integer orgId) throws Exception;

	/**
	 * 更新油罐信息
	 * 
	 * @param tankJson
	 * @param orgId
	 * @return
	 * @throws Exception
	 */
	Map<String, Object> updateOrSave(HttpServletRequest request, String tankJson, Integer orgId) throws Exception;
}
